"{ Package: 'stx:libscm/gitHub' }"

"{ NameSpace: Smalltalk }"

Object subclass:#GitHubSmalltalkPackageReader
	instanceVariableNames:'changeSet packageDirectory packageName'
	classVariableNames:''
	poolDictionaries:''
	category:'SCM-GitHub-Package-Reader'
!

!GitHubSmalltalkPackageReader class methodsFor:'documentation'!

documentation
"
    a q&d hack, to read packages/classes from github
    
    read a .package definition as stored by Pharo/Squeak in gitHub.

    [author:]
        Claus Gittinger

    [instance variables:]

    [class variables:]

    [see also:]

"
! !

!GitHubSmalltalkPackageReader class methodsFor:'reading'!

readPackageFrom:aPackageDirectory
    "read a .package folder; return a changeSet for that package"

     ^ self new 
        packageDirectory:aPackageDirectory;
        readPackage;
        changeSet.

    "Created: / 30-06-2018 / 18:16:04 / Claus Gittinger"
! !

!GitHubSmalltalkPackageReader methodsFor:'accessing'!

changeSet
    ^ changeSet
!

packageDirectory:aDirectoryName
    packageDirectory := aDirectoryName asFilename.

    "Modified: / 30-06-2018 / 18:20:35 / Claus Gittinger"
! !

!GitHubSmalltalkPackageReader methodsFor:'reading'!

readClasses
    packageDirectory directoriesDo:[:eachDirectory |
        (eachDirectory hasSuffix:'class') ifTrue:[
            GitHubSmalltalkClassReader new
                changeSet:changeSet;
                classDirectory:eachDirectory;
                readClass.
        ].        
    ].

    "
     |changes|

     changes := self new 
        classDirectory:'/Users/cg/work/stx/goodies/smaCC/SmaCC-master/SmaCC-Cucumber.package/CucumberParserTests.class';
        readClass;
        changeSet.
     ChangeSetBrowser openOn:changes    
    "

    "Created: / 30-06-2018 / 18:24:49 / Claus Gittinger"
!

readPackage
    |props|

    changeSet := ChangeSet new.
    
    props := JSONReader fromJSON:(packageDirectory / 'properties.json') contentsOfEntireFile.
    props notEmptyOrNil ifTrue:[self halt].
    
    packageName := packageDirectory withoutSuffix baseName .

    self readClasses.

    "
     |changes|

     changes := self new 
        packageDirectory:'/Users/cg/work/stx/goodies/smaCC/SmaCC-master/SmaCC-Cucumber.package';
        readPackage;
        changeSet.
     ChangeSetBrowser openOn:changes    
    "

    "Created: / 30-06-2018 / 18:20:13 / Claus Gittinger"
! !

!GitHubSmalltalkPackageReader class methodsFor:'documentation'!

version
    ^ '$Header$'
!

version_CVS
    ^ '$Header$'
! !

